# AherNet (for paper review)

# Environment

These codes are implemented in TensorFlow (1.12.3) GPU version. 

The version of operation system in docker is Ubuntu16.04.

The python version is 3.6.7. 

The GPU is NVIDIA Tesla P40 (23GB) and the CUDA version is CUDA 9.0, cudnn version is 7.3.1

# Note
This repository includes all the pure codes and configuration files of the final setting in the paper (From ActivityNet v1.3 to Kinetics-600, i.e., ANet -> K600).

All the training/validation features and related information files of the dataset are not included in the repository since they are too large, which will be released on Git in the future. 

You could run the code with the debug model in Visual Studio Code and check how the optimization process of whole AherNet run. 


# Training of AherNet

The training script is `aher_k600_train.py`. 
Once you have all the training features and information files, you could run

```
CUDA_VISIBLE_DEVICES=0 python3 aher_k600_train.py
```
The code annotations in this file have several parts which present the data flow, loss function and optimization order during each iteration. 

The optimization order corresponds to the optimization strategy of AherNet which is mentioned in Sec 3.4 of the paper. 

The parameters fixing or freezing during optimization can be implemented through TensorFlow. It can set several specific variables of networks for optimization in once forward-backward.


# Testing of AherNet on Kinetics-600

The testing script is `aher_k600_test.py`. 
Once you have all the testing features and information files, you could run

```
CUDA_VISIBLE_DEVICES=0 python3 aher_k600_test.py
```
You can evaluate several snapshots (models) during testing stage to find which model is the best one.

After the evaluation, you can get the results of ".json" file which will be evaluated by `./evaluation/get_proposal_performance.py` or `./evaluation/get_detection_performance.py` for temporal action proposal and temporal action localization evaluation.


# Where to find the structure mentioned in the paper
```
1D backbone structure: aher_anet.py line 1452-1473

Weight transfer function structure: aher_anet.py line 1087-1095

Context generators structure: aher_adv.py line 48-59
```